summaryrefslogtreecommitdiff
path: root/scripts/archive-source.sh
diff options
context:
space:
mode:
authorFam Zheng <famz@redhat.com>2017-09-05 10:11:52 +0800
committerFam Zheng <famz@redhat.com>2017-09-22 10:46:25 +0800
commit6b560c76ca3cb90d5f7562022d872401c4ee8bae (patch)
treeed4034bedf548655d828830205bbbeb2f34053d8 /scripts/archive-source.sh
parent22491a2f2ee75dbd68058abcb1ab9feee140ba50 (diff)
downloadqemu-6b560c76ca3cb90d5f7562022d872401c4ee8bae.tar.gz
scripts: Add archive-source.sh
Signed-off-by: Fam Zheng <famz@redhat.com> Reviewed-by: Eric Blake <eblake@redhat.com>
Diffstat (limited to 'scripts/archive-source.sh')
-rwxr-xr-xscripts/archive-source.sh51
1 files changed, 51 insertions, 0 deletions
diff --git a/scripts/archive-source.sh b/scripts/archive-source.sh
new file mode 100755
index 0000000000..c4e7d98f4d
--- /dev/null
+++ b/scripts/archive-source.sh
@@ -0,0 +1,51 @@
+#!/bin/bash
+#
+# Author: Fam Zheng <famz@redhat.com>
+#
+# Archive source tree, including submodules. This is created for test code to
+# export the source files, in order to be built in a different environment,
+# such as in a docker instance or VM.
+#
+# This code is licensed under the GPL version 2 or later. See
+# the COPYING file in the top-level directory.
+
+error() {
+ printf %s\\n "$*" >&2
+ exit 1
+}
+
+if test $# -lt 1; then
+ error "Usage: $0 <output tarball>"
+fi
+
+tar_file="$1"
+list_file="$1.list"
+submodules=$(git submodule foreach --recursive --quiet 'echo $name')
+
+if test $? -ne 0; then
+ error "git submodule command failed"
+fi
+
+trap "status=$?; rm -f \"$list_file\"; exit \$status" 0 1 2 3 15
+
+if test -n "$submodules"; then
+ {
+ git ls-files || error "git ls-files failed"
+ for sm in $submodules; do
+ (cd $sm; git ls-files) | sed "s:^:$sm/:"
+ if test "${PIPESTATUS[*]}" != "0 0"; then
+ error "git ls-files in submodule $sm failed"
+ fi
+ done
+ } | grep -x -v $(for sm in $submodules; do echo "-e $sm"; done) > "$list_file"
+else
+ git ls-files > "$list_file"
+fi
+
+if test $? -ne 0; then
+ error "failed to generate list file"
+fi
+
+tar -cf "$tar_file" -T "$list_file" || error "failed to create tar file"
+
+exit 0